#!/usr/bin/env perl

my $gpath = $ENV{GPT_LOCATION};

if (!defined($gpath))
{
  $gpath = $ENV{GLOBUS_LOCATION};
}

if (!defined($gpath))
{
   die "GPT_LOCATION or GLOBUS_LOCATION needs to be set before running this script"
}

@INC = (@INC, "$gpath/lib/perl");

require Grid::GPT::Setup;

my $metadata = new Grid::GPT::Setup(package_name => "globus_gatekeeper_setup");

my $globusdir = $ENV{GLOBUS_LOCATION};
my $setupdir = "$globusdir/setup/globus/";
my $gk_conf = "$globusdir/etc/globus-gatekeeper.conf";

print "Creating gatekeeper configuration file...\n";

if ( ! open(CONF, ">$gk_conf") )
{
   die "open failed for $gk_conf";
}

my $x509_cert_dir  = $ENV{X509_CERT_DIR}  || "/etc/grid-security/certificates";
my $x509_user_cert = $ENV{X509_USER_CERT} || "/etc/grid-security/hostcert.pem";
my $x509_user_key  = $ENV{X509_USER_KEY}  || "/etc/grid-security/hostkey.pem";
my $gridmap        = $ENV{GRIDMAP}        || "/etc/grid-security/grid-mapfile";

print CONF <<EOF;
  -x509_cert_dir $x509_cert_dir
  -x509_user_cert $x509_user_cert
  -x509_user_key $x509_user_key
  -gridmap $gridmap
  -home $globusdir
  -e libexec
  -logfile var/globus-gatekeeper.log
  -port 2119
  -grid_services etc/grid-services
  -inetd
EOF

print "Done\n";

if ( ! -d "$globusdir/var" )
{
   print "Creating gatekeeper log directory...\n";
   system "mkdir -p $globusdir/var";
   print "Done\n";
}

if ( ! -d "$globusdir/etc/grid-services" )
{
   print "Creating grid services directory...\n";
   system "mkdir -p $globusdir/etc/grid-services";
   print "Done\n";
}

$metadata->finish();
